/***************************************************************************
                            -  description
                             -------------------
    begin                : Thu May 18 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "extern.h"
#include "type.h"
#include <stdio.h>

// predicate(succ(Number,Number))
// mode(*,succ(+,-))
// returns the successor of a number
ModeFactCoors *succ ( INTTYPE *coor ) {
  static INTTYPE next;
  static ListModeFactCoorsElement mfc = { &next, NULL };
  if ( *coor < 247 ) {
    next = *coor + 1;
    return new ListModeFactCoors ( &mfc );
  }
  else
    return NULL;
}

// predicate(surr(Number,Number))
// mode(*,surr(+,-))
// returns the surrounding numbers of the current number
ModeFactCoors *surr ( INTTYPE *coor ) {
  static INTTYPE next, prev;
  static ListModeFactCoorsElement mfc2 = { &next, NULL }, mfc1 = { &prev, &mfc2 };
  if ( *coor < 247 && *coor > 0 ) {
    next = *coor + 1;
    prev = *coor - 1;
    return new ListModeFactCoors ( &mfc1 );
  }
  else
    return NULL;
}

// predicate(is(number,Number))
// mode(*,is(+,+))
// returns whether the first parameter equals the second
bool is ( INTTYPE *coor ) {
  return coor[0] == coor[1];
}

BEGIN_EXTERNAL_INIT
END_EXTERNAL_INIT

BEGIN_EXTERNAL_MODEFACTTABLES
  EXTERNAL_MODEFACTTABLE ( succ )
  EXTERNAL_MODEFACTTABLE ( surr )
END_EXTERNAL_MODEFACTTABLES

BEGIN_EXTERNAL_FACTTABLES
  EXTERNAL_FACTTABLE ( is )
END_EXTERNAL_FACTTABLES
