/***************************************************************************
                          floatrangefacttable.h  -  dtfarmer
                             -------------------
    begin                : Wed Sep 13 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLOATRANGEFACTTABLE_H
#define FLOATRANGEFACTTABLE_H
#include "facttable.h"
#include "type.h"

/**This `table' can be assigned to modes for inequality float checks.
  *During execution, it collects values and determines the best split value.
  *@author Siegfried Nijssen
  */

struct Test;

class FloatRangeFactTable : public BaseFactTable  {
private:
  void redistribute ( Test *test );
  double toDouble ( int i );
public: 
  FloatRangeFactTable();
  ~FloatRangeFactTable();
  bool getFact ( INTTYPE *coor );
  void finish ();

    /* this function is called by the constructor of a node, to
     * initialize the 'additionaldata' of the node. The default sets
     * additionaldata to NULL; derived classes can override
     */
  void init ();

    /* this function can be used to clear up information in additionaldata
     * when the node is removed
     */
  void remove ();

    /* the keyfacttables have place for additional data for each example
     * separately. This function returns the information which is to be placed
     * in this location for this kind of table. Optionally uses a node to
     * determine the contents.
     * the default returns NULL.
     */
  void *determineAdditionalData ();
    /* allows for application of the MDL principle */
  double additionalPunishment ();

  char *string ();
};

#endif
