/***************************************************************************
                          globaldata.cc  -  description
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "output.h"
#include "globaldata.h"

TypeTable typetable;
PredicateTable predicatetable;
ModeTable modetable;
bool showconstantnames = false;
bool gainratio = false;
int leafthreshold = 1;
int otherclassleafthreshold = 0;
KeyFactTables *keyfacttables, *test_keyfacttables, *train_keyfacttables;
int *keynrtopnr;
int crossvalidation = 10;
int maxlookahead = 5;
int lookaheadfraction = 10;
double lookaheadpunishment = 2.0;
double addlap = 0.5;
bool constlapunishment = true;
double minimpurityincrease = 0.01;
bool mdl = false;
bool othertest = false;
bool shuffle = false;
bool prune = true;
bool usefirstattributeforvalidation = false;
bool displaydistribution = false;
bool validationtable = false;
PredicateData *akeypredicate;

void globaldata_print () {
  OUT << "Show constant names: " << ( showconstantnames ? "ON": "OFF" ) << endl
      << "MDL principle: " << ( mdl? "YES" : "NO" ) << endl
      << "Mean-test in stead of Equal continuous: " << ( othertest ? "YES" : "NO" ) << endl
      << "Gain ratio principle: " << ( gainratio? "YES": "NO" ) << endl
      << "Shuffle for crossvalidation: " << ( shuffle? "YES" : "NO" ) << endl
      << "Leaf threshold: " << leafthreshold << endl
      << "Other class leaf threshold: " << otherclassleafthreshold << endl
      << "Lookahead fraction: " << lookaheadfraction << endl
      << "Lookahead punishment: " << lookaheadpunishment << endl
      << "Additional lookahead punishment: " << addlap << endl
      << "Constant lookahead punishment: " << ( constlapunishment ? "YES": "NO" ) << endl
      << "Max lookahead: " << maxlookahead << endl
      << "Cross validation: " << crossvalidation << endl
      << "Use first attribute for validation: " << ( usefirstattributeforvalidation ? "YES" : "NO" ) << endl
      << "Display distribution information: " << ( displaydistribution ? "YES" : "NO" ) << endl
      << "(Safe)Prune after building: " << ( prune ? "YES": "NO" ) << endl
      << "Print validation table: " << ( validationtable ? "YES": "NO" ) << endl
      << "Min impurity increase: " << minimpurityincrease << endl;
  OUT_F
}
