/***************************************************************************
                          keyfacttable.h  -  dtfarmer
                             -------------------
    begin                : Mon Aug 7 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KEYFACTTABLE_H
#define KEYFACTTABLE_H
#include "basetable.h"
#include "type.h"
#include <stdlib.h>


/**
  *@author Siegfried Nijssen
  */

struct KeyFactTableCell {
  INTTYPE *value;
  void *additionaldata;
  KeyFactTableCell *next;
};

class KeyFactTable:public BaseTable {
  public:
    typedef void (*Iterator) ( INTTYPE *value, void *additionaldata, void *extraparams );
    KeyFactTable ( int outputdim, bool copy = true );
    ~KeyFactTable ();
    void setCopy ( bool copy );
    void addFact ( INTTYPE *value, void *additionaldata = NULL );
    INTTYPE *popFact ();
    void iterate ( Iterator iterator, void *extraparams );
    void shuffle ();
    int getSize () { return size; }
    void append ( KeyFactTable *kft ); // empties kft, but not deletes it
  private:
    bool copy;
    int outputdim;
    int size;
    KeyFactTableCell *first, *last;
};

#endif
