/***************************************************************************
                          typetable.h  -  description
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef TYPETABLE_H
#define TYPETABLE_H
#include "nametable.h"
#include "floattable.h"

struct TypeData {
   // constant names or floats belonging with the numbers, mixing
   // not allowed, determined by the first type added
  union {
    NameTable *constantnametable;
    FloatTable *floattable;
    void *table;
  } constanttable;
  bool names;
  int constnumbers;
  int maxsize;
  TypeData *next;
};

class TypeTable {
  public:
    TypeTable ();
    ~TypeTable ();
    bool addConstant ( char *constant_name, char *type_name );
    void addType ( char *type_name, int n = 0 );
      // n upperbound of constants or floats, might be less when giving the list
    void getType ( char *type_name, int &typenr, int &nrofconstants );
    void getConstant ( char *constant_name, int &typenr, int &constantnr );
     // valid on all types, also floats, which are converted to strings:
    char *getConstantName ( int typenr, int constantnr );
     // only valid on typenr which are floats:
    double getConstantDouble ( int typenr, int constantnr );
    char *getTypeName ( int typenr );
    void fillArray ();
      /* fills an array indexed from type nr to nr of constants */
    void print ();
    void set_number_imm ( bool val ) { number_imm = val; }
    int size;
    TypeData **array;
  private:
    int actunroftypes;
    bool filledarray;
    TypeData *types;
    NameTable typenames;
    bool number_imm;
};

#endif






