/***************************************************************************
                          qgraphtree.h  -  Gilder header
                             -------------------
    begin                : Sun Sep 24 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QGRAPHTREE_H
#define QGRAPHTREE_H

#include <qwidget.h>
#include <qscrollview.h>
#include "gilder/tree.h"
#include "qgraphatom.h"
#include "qlist.h"

/**A view showing a decision tree
  *@author Siegfried Nijssen
  */

class QGraphTree : public QScrollView  {
  Q_OBJECT
public:
  QGraphTree(QWidget *parent=0, const char *name=0);
  ~QGraphTree();
  void setTree ( Node *root, int maxdepth );
  int w, h;
protected:
  void drawContentsOffset ( QPainter * p, int offsetx, int offsety, int clipx, int clipy, int clipw, int cliph );
private:
  QGraphAtom *addNode ( Node *node, int depth, int *maxx, QList<int> &il );
  QGraphAtom *addNode ( char clas, int depth, int *maxx, QList<int> &il );
  Node *root;
  QList<QGraphAtom> qatoms;
  struct QGraphAtomArrow {
    QGraphAtom *beginatom, *endatom;
  };
  QList<QGraphAtomArrow> qlines;
};

#endif
