/***************************************************************************
                          visualgilderdoc.h  -  Gilder header
                             -------------------
    begin                : Sun Sep 24 16:13:12 CEST 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef VISUALGILDERDOC_H
#define VISUALGILDERDOC_H

// include files for QT
#include <qobject.h>
#include <qlist.h>

// application specific includes

/**
  * the Document Class
  */
struct Node;

struct TreeData {
  Node *root;
  int cnt, maxdepth;
  double accur;
};

class VisualgilderDoc : public QObject
{
  Q_OBJECT

  public:
    VisualgilderDoc();
    ~VisualgilderDoc();
    void newDoc();
    bool save();
    bool saveAs(const QString &filename);
    bool load(const QString &filename);
    bool isModified() const;
    QList<TreeData> tdl;

  signals:
    void documentChanged();

  protected:
    bool modified;
};

#endif
