/***************************************************************************
                          visualgilderview.h  -  Gilder header
                             -------------------
    begin                : Sun Sep 24 16:13:12 CEST 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VISUALGILDERVIEW_H
#define VISUALGILDERVIEW_H

// include files for QT
#include <qwidget.h>
#include <qsplitter.h>
#include <qlistview.h>

// application specific includes
#include "visualgilderdoc.h"
#include "qgraphtree.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class VisualgilderView : public QSplitter
{
  Q_OBJECT
  public:
    VisualgilderView(QWidget *parent=0, VisualgilderDoc* doc=0);
    ~VisualgilderView();

  protected slots:
    void slotDocumentChanged();
    void slotSelectionChanged ( QListViewItem *qlvi );
  private:
    void addTree ( TreeData *td );
    QGraphTree *graphtree;
    QListView *listview;
    class treeListViewItem:public QListViewItem {
      public:
        treeListViewItem ( QListView *lv, TreeData *td );
        const char *text ( int column ) const;
        TreeData *td;
    };
    VisualgilderDoc *doc;

};

#endif
